#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <zlib.h>

#define REPLACEERROR printf



void test_large_inflate(char *compr, ulong comprLen, char *uncompr, char uncomprLen)
{
	int err;
	z_stream d_stream; /* decompression stream */

	strcpy((char*)uncompr, "garbage");

	d_stream.zalloc = (alloc_func)0;
	d_stream.zfree = (free_func)0;
	d_stream.opaque = (voidpf)0;

	d_stream.next_in  = compr;
	d_stream.avail_in = (uInt)comprLen;

	err = inflateInit(&d_stream);
	if (err != Z_OK) { \
		REPLACEERROR("inflateInit\n");
		exit(1);
	}

	for (;;) {
		d_stream.next_out = uncompr;            /* discard the output */
		d_stream.avail_out = (uInt)uncomprLen;
		err = inflate(&d_stream, Z_NO_FLUSH);
		if (err == Z_STREAM_END) break;
		if (err != Z_OK) { \
			REPLACEERROR("inflate\n");
			exit(1);
		}
	}

	err = inflateEnd(&d_stream);
	if (err != Z_OK) { \
		REPLACEERROR("inflateEnd\n");
		exit(1);
	}

	if (d_stream.total_out != 2*uncomprLen + comprLen/2) {
		fprintf(stderr, "bad large inflate: %ld\n", d_stream.total_out);
		//exit(1);
	} else {
		printf("large_inflate(): OK\n");
	}
}

int main(int argc, char **argv)
{
	char buffer[2048],buffer2[2048];
	FILE *t;
	t= fopen("test.z","rb");
	fread(&buffer,2048,1,t);
	fclose(t);
	
	test_large_inflate(&buffer, 27,&buffer2,94);
	
	printf("out: %s\n",buffer2);
	
	return 0;
}
